<?php

// ACP Header - START
if (!empty($setmodules))
{
	$module['Users'][''] = basename(__FILE__);
	return;
}
require('./pagestart.php');
// ACP Header - END


$start = (@$_REQUEST['start']) ? abs(intval($_REQUEST['start'])) : 0;
$mode  = (@$_REQUEST['mode']) ? (string) $_REQUEST['mode'] : 'joined';
$sort_order = (@$_REQUEST['order']) ? (($_REQUEST['order'] == 'ASC') ? 'ASC' : 'DESC') : 'ASC';

//
// Memberlist sorting
//
$mode_types_text = array(
	$lang['Sort_Joined'],
	$lang['Sort_Username'],
	$lang['Sort_Posts'],
	$lang['Sort_Top_Ten'],

	$lang['BT_RATIO'],
	$lang['DOWNLOADED'],
	$lang['UPLOADED'],
	$lang['RELEASED'],
	$lang['BT_BONUS_UP']
);

$mode_types = array(
	'joined',
	'username',
	'posts',
	'topten',

	'ratio',
	'downloaded',
	'uploaded',
	'released',
	'bonus_up',
);



// <select> mode
$select_sort_mode = '<select name="mode">';

for ($i=0, $cnt=count($mode_types_text); $i < $cnt; $i++)
{
	$selected = ( $mode == $mode_types[$i] ) ? ' selected="selected"' : '';
	$select_sort_mode .= '<option value="' . $mode_types[$i] . '"' . $selected . '>' . $mode_types_text[$i] . '</option>';
}
$select_sort_mode .= '</select>';



// <select> order
$select_sort_order = '<select name="order">';

if ($sort_order == 'ASC')
{
	$select_sort_order .= '<option value="ASC" selected="selected">' . $lang['ASC'] . '</option><option value="DESC">' . $lang['DESC'] . '</option>';
}
else
{
	$select_sort_order .= '<option value="ASC">' . $lang['ASC'] . '</option><option value="DESC" selected="selected">' . $lang['DESC'] . '</option>';
}
$select_sort_order .= '</select>';




//
// Generate page
//
$template->assign_vars(array(
	'S_MODE_SELECT' => $select_sort_mode,
	'S_ORDER_SELECT' => $select_sort_order,
	'S_MODE_ACTION' => append_sid("admin_user_up.$phpEx"))
);

switch( $mode )
{
	case 'joined':
		$order_by = "user_id $sort_order LIMIT $start, " . $board_config['topics_per_page'];
		break;
	case 'username':
		$order_by = "username $sort_order LIMIT $start, " . $board_config['topics_per_page'];
		break;
	case 'posts':
		$order_by = "user_posts $sort_order LIMIT $start, " . $board_config['topics_per_page'];
		break;
	case 'topten':
		$order_by = "user_posts $sort_order LIMIT 10";
		break;

	case 'ratio':
		$order_by = "user_posts $sort_order LIMIT $start, " . $board_config['topics_per_page'];
		break;
	case 'downloaded':
		$order_by = "u_down_total $sort_order LIMIT $start, " . $board_config['topics_per_page'];
		break;
	case 'uploaded':
		$order_by = "u_up_total $sort_order LIMIT $start, " . $board_config['topics_per_page'];
		break;
	case 'released':
		$order_by = "u_up_release $sort_order LIMIT $start, " . $board_config['topics_per_page'];
		break;
	case 'bonus_up':
		$order_by = "u_up_bonus $sort_order LIMIT $start, " . $board_config['topics_per_page'];
		break;
	default:
		$order_by = "user_regdate $sort_order LIMIT $start, " . $board_config['topics_per_page'];
		$mode = 'joined';
		break;
}



// per-letter selection
$by_letter = 'all';
$letters_range = 'a-z-';
$select_letter = $letter_sql = '';

$by_letter_req = (@$_REQUEST['letter']) ? strtolower(trim($_REQUEST['letter'])) : false;

if ($by_letter_req)
{
	if ($by_letter_req === 'all')
	{
		$by_letter = 'all';
		$letter_sql = '';
	}
	else if ($by_letter_req === 'others')
	{
		$by_letter = 'others';
		$letter_sql = "username REGEXP '^[!-@\\[-`].*$'";
	}
	else if ($letter_req = preg_replace("#[^$letters_range]#", '', $by_letter_req[0]))
	{
		$by_letter = $db->escape($letter_req);
		$letter_sql = "LOWER(username) LIKE '$by_letter%'";
	}
}

// ENG
for ($i=ord('A'), $cnt=ord('Z'); $i <= $cnt; $i++)
{
  $select_letter .= ($by_letter == chr($i)) ? '<b>'. chr($i) .'</b>&nbsp;' : '<a class="genmed" href="'. append_sid("admin_user_up.$phpEx?letter=". chr($i) ."&amp;mode=$mode&amp;order=$sort_order") .'">'. chr($i) .'</a>&nbsp;';
}

// RUS
$select_letter .= ': ';
for ($i=ord(''), $cnt=ord(''); $i <= $cnt; $i++)
{
  $select_letter .= ($by_letter == chr($i)) ? '<b>'. chr($i) .'</b>&nbsp;' : '<a class="genmed" href="'. append_sid("admin_user_up.$phpEx?letter=". chr($i) ."&amp;mode=$mode&amp;order=$sort_order") .'">'. chr($i) .'</a>&nbsp;';
}


$select_letter .= ':&nbsp;';
$select_letter .= ($by_letter == 'others') ? '<b>'. $lang['Others'] .'</b>&nbsp;' : '<a class="genmed" href="'. append_sid("admin_user_up.$phpEx?letter=others&amp;mode=$mode&amp;order=$sort_order") .'">'. $lang['Others'] .'</a>&nbsp;';
$select_letter .= ':&nbsp;';
$select_letter .= ($by_letter == 'all') ? '<b>'. $lang['All'] .'</b>' : '<a class="genmed" href="'. append_sid("admin_user_up.$phpEx?letter=all&amp;mode=$mode&amp;order=$sort_order") .'">'. $lang['All'] .'</a>';

$template->assign_vars(array(
	'L_SORT_PER_LETTER' => $lang['Sort_per_letter'],
	'S_LETTER_SELECT'   => $select_letter,
	'S_LETTER_HIDDEN'   => '<input type="hidden" name="letter" value="'. $by_letter .'">',
));



// per-letter selection end

$sql = 'SELECT _u.username, _u.user_id, _u.user_opt, _u.user_posts, _u.user_regdate, _ubt.u_down_total, _ubt.u_up_total, _ubt.u_up_release, _ubt.u_up_bonus
        FROM '. USERS_TABLE .' _u, '. BT_USERS_TABLE . " _ubt WHERE _u.user_id <> ". ANONYMOUS ." and _u.user_id = _ubt.user_id";


$sql .= ($letter_sql) ? " AND $letter_sql" : '';
$sql .= " ORDER BY $order_by";

$result = $db->sql_query($sql) OR message_die(GENERAL_ERROR, 'Could not query users', '', __LINE__, __FILE__, $sql);

if ( $row = $db->sql_fetchrow($result) )
{
	$i = 0;
	do
	{
		$username = $row['username'];
		$user_id = $row['user_id'];
		$joined = create_date($lang['DATE_FORMAT'], $row['user_regdate'], $board_config['board_timezone']);
		$posts = $row['user_posts'];
		
		$download_ = $row['u_down_total'];
		$upload_ = $row['u_up_total'];
		$release_ = $row['u_up_release'];
		$bonus_ = $row['u_up_bonus'];

		$reit_ = (!empty($row['u_down_total']) && $row['u_down_total'] > MIN_DL_FOR_RATIO)
		? round((($row['u_up_total'] + $row['u_up_release'] + $row['u_up_bonus']) / $row['u_down_total']), 2): null;

		$temp_url = append_sid("../profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$user_id");
		$profile = '<a href="' . $temp_url . '">' . $lang['Read_profile'] . '</a>';
		$row_class = !($i % 2) ? 'row1' : 'row2';

		$template->assign_block_vars('memberrow', array(
			'ROW_NUMBER' => $i + ( $start + 1 ),
			'ROW_CLASS' => $row_class,
			'USERNAME' => $username,
			'JOINED' => $joined,
			'POSTS' => $posts,
			'BT_RATIO' => $reit_,
			'DOWNLOADED' => humn_size($download_),
			'UPLOADED' => humn_size($upload_),
			'RELEASED' => humn_size($release_),
			'BT_BONUS_UP' => humn_size($bonus_),
			'U_VIEWPROFILE' => append_sid("../profile.$phpEx?mode=viewprofile&amp;". POST_USERS_URL ."=$user_id"))
		);
		$i++;
	}
	while ( $row = $db->sql_fetchrow($result) );
	$db->sql_freeresult($result);
}

if ( $mode != 'topten' || $board_config['topics_per_page'] < 10 )
{
	$sql = "SELECT COUNT(*) AS total FROM ". USERS_TABLE;
	$sql .=	($letter_sql) ? " WHERE $letter_sql" : '';
	if (!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Error getting total users', '', __LINE__, __FILE__, $sql);
	}
	if ($total = $db->sql_fetchrow($result))
	{
		$total_members = $total['total'];
		$pagination = generate_pagination("admin_user_up.$phpEx?mode=$mode&amp;order=$sort_order&amp;letter=$by_letter", $total_members, $board_config['topics_per_page'], $start). '&nbsp;';
	}
	$db->sql_freeresult($result);
}
else
{
	$pagination = '&nbsp;';
	$total_members = 10;
}

$template->assign_vars(array(
	'PAGE_TITLE' => $lang['Users'],
	'PAGINATION' => $pagination,
	'PAGE_NUMBER' => sprintf($lang['Page_of'], ( floor( $start / $board_config['topics_per_page'] ) + 1 ), ceil( $total_members / $board_config['topics_per_page'] )),
));

print_page('admin_users_up.tpl', 'admin');
