<?php 
define('IN_PHPBB', true);
define('BB_ROOT', './');
$phpEx = substr(strrchr(__FILE__, '.'), 1);
require(BB_ROOT ."common.$phpEx");

if (!$bb_cfg['gallery_enabled'])
{
	message_die(GENERAL_MESSAGE, 'Gallery disabled');
}

// Start session management
$user->session_start(array('req_login' => true));

function create_thumb ($dir, $name, $att)
{
	$infile = $dir . $name . $att;
	if ($att == ".jpg" || $att == ".jpeg")
		$im = imagecreatefromjpeg($infile);
	elseif ($att == ".png")
		$im = imagecreatefrompng($infile);
	elseif ($att == ".gif")
		$im = imagecreatefromgif($infile);

	$oh = imagesy($im);
	$ow = imagesx($im);
	$r = $oh/$ow;
	$newh = 200;
	$neww = $newh/$r;
	$outfile = $dir ."thumb_". $name . $att;
	$im1 = imagecreatetruecolor($neww,$newh);
	imagecopyresampled($im1, $im, 0, 0, 0, 0, $neww, $newh, imagesx($im), imagesy($im));
	imagejpeg($im1, $outfile, 75);
	imagedestroy($im);
	imagedestroy($im1);
}

function paste_links($links, $thumbs = '')
{
	global $links_all, $thumbs_all;

	if (is_array($links))
	{
		$link = implode(' ', $links);
		$img  = '[img]'. implode('[/img] [img]', $links) .'[/img]';
		
		$thumb = '';
		for ($i = 0; $i < count($links); $i++)
		{
			$thumb .= '[url='.$links[$i].'][img]'. $thumbs[$i] .'[/img][/url]';
		}
	}
	else
	{
		$link = trim($links);
		$img  = '[img]'. $links .'[/img]';

		$thumb = '[url='.$link.'][img]'. $thumbs .'[/img][/url]';
	}
	$spoiler = '[spoiler=""]' . $img . '[/spoiler]';
	
	$text  = (!is_array($links)) ? '<br /><a href='. $link .' target=_blank>'. $link .'</a><br>' : '';
	$text .= (!is_array($links)) ? '<br /><img src='. $link .' alt=" ">' : '';
	$text .= '<br /><h4 align="left"><b>  :</b></h4><input type="text" readonly="" value="'. $link .'" size="140" onclick="f2(this);">';
	$text .= '<br /><h4 align="left"><b>  c:</b></h4><input type="text" readonly="" value="'.$img.'" size="140" onclick="f2(this);">';
	if ($thumbs)
	{
		$text .='<br /><h4 align="left"><b>  c  :</b></h4><input type="text" readonly="" value="'. $thumb .'" size="140" onclick="f2(this);">';
	}
	$text .= (!is_array($links)) ? '<br /><h4 align="left"><b>   :</b></h4><input type="text" readonly="" value="[img=right]'. $link .'[/img]" size="140" onclick="f2(this);">' : '';
	$text .= '<br /><h4 align="left"><b> c:</b></h4><input type="text" readonly="" value=\''. $spoiler .'\' size="140" onclick="f2(this);">';

	$links_all[] = $links;
	$thumbs_all[] = $thumbs;
	
	return $text;
}

function upload_file ($files_ary, $idx)
{
	global $max_size, $allowed_ext, $create_thumb, $dir, $url;

	if (empty($files_ary))
		message_die(GENERAL_ERROR, "<hr><span style='color:red'><h2>  .</h2></span><hr><br><center><a href='gallery.php'>  </a></center><br><hr>");
	if ($files_ary['size'][$idx] > $max_size)
		message_die(GENERAL_ERROR, "<hr><span style='color:red'><h2>    .</h2></span><hr><br><center><a href='gallery.php'>  </a></center><br><hr>");

	$name = strtolower($files_ary['name'][$idx]);
	$ext  = substr(strrchr($name, '.'), 1);
	
	$allow = in_array($ext, $allowed_ext);
	$att   = '.'. $ext;

	$thumb = false;
	
	if ($allow)
	{
		$name = md5_file($files_ary['tmp_name'][$idx]);

		if (file_exists($dir . $name . $att))
		{
			if ($create_thumb && !file_exists($dir .'thumb_'. $name . $att))
			{
				create_thumb($dir, $name, $att);
				$thumb = $url . $dir ."thumb_". $name . $att;
			}
			$msg = '<hr>   .'. paste_links($url . $dir . $name . $att, $thumb) .'</a>';
		}
		else
		{
			if (copy($files_ary['tmp_name'][$idx], $dir.$name.$att))
			{
				if ($create_thumb)
				{
					create_thumb($dir, $name, $att);
					$thumb = $url . $dir ."thumb_". $name . $att;
				}
				$msg = '<hr>  .'. paste_links($url . $dir . $name . $att, $thumb) .'</a>';
			}
			else $msg = "<hr><span style='color:red'>  . .</span>";
		}
		if (IS_ADMIN)
		{
			$msg .= "<br><br>";
			$msg .= "<span style='color:red'><b>   : &nbsp; &nbsp;</b></span>";
			$msg .= "<a href=\"gallery.php?go=delete&fn=".$name.$att."\">".$url."gallery.php?go=delete&fn=".$name.$att."</a>";
		}
	}
	else $msg = "<hr><span style='color:red'>  .</span>";

	return $msg;
}

$go = isset($_GET['go']) ? $_GET['go'] : '';
$max_size = $bb_cfg['pic_max_size'];
$dir = $bb_cfg['pic_dir'];
$url = make_url('/');

$msg = '';
$links_all = $thumbs_all = array();

$allowed_ext = array(
	'jpeg',
	'jpg',
	'png',
	'gif',
);

if ($go == 'delete' && IS_ADMIN)
{
	$fn = empty($_GET['fn']) ? '' : $_GET['fn'];

	$pic  = $dir . $fn;
	$prev = $dir ."thumb_". $fn;
	if (!is_file($pic)) message_die(GENERAL_ERROR, 'File not exist');

	if (unlink($pic))
	{
		@unlink($prev);
		message_die(GENERAL_MESSAGE, "<center><span style='color:red'><h2>  </h2></span><br><a href='gallery.php'>  </a></center>");
	}
	else
		message_die(GENERAL_ERROR, "<center><span style='color:red'><h2></h2></span><br><a href='gallery.php'>  </a></center>");
}

if ($go == 'upload')
{
	$create_thumb = (isset($_POST['create_thumb'])) ? true : false;

	for ($i = 0; $i < count($_FILES['imgfile']['name']); $i++)
	{
		$msg .= upload_file ($_FILES['imgfile'], $i);
	}

	if (count($_FILES['imgfile']['name']) > 1)
	{
		$msg .= '<hr />'. paste_links ($links_all, $thumbs_all);
	}
}

$template->assign_vars(array(
	'MAX_SIZE' => humn_size($max_size),
	'MSG' => $msg,
));

print_page('gallery.tpl');
?> 