<?php
/***************************************************************************
 *                           usercp_viewprofile.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: usercp_viewprofile.php,v 1.5.2.6 2005/09/14 18:14:30 acydburn Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/
if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
	exit;
}

$datastore->enqueue(array(
	'ranks',
));

if (!$userdata['session_logged_in'])
{
	redirect(append_sid("login.$phpEx?redirect={$_SERVER['REQUEST_URI']}", TRUE));
}
if ( empty($HTTP_GET_VARS[POST_USERS_URL]) || $HTTP_GET_VARS[POST_USERS_URL] == ANONYMOUS )
{
	message_die(GENERAL_MESSAGE, $lang['No_user_id_specified']);
}
$profiledata = get_userdata($HTTP_GET_VARS[POST_USERS_URL]);

if (!$profiledata)
{
	message_die(GENERAL_MESSAGE, $lang['No_user_id_specified']);
}

//
// Calculate the number of days this user has been a member ($memberdays)
// Then calculate their posts per day
//
$regdate = $profiledata['user_regdate'];
$memberdays = max(1, round( ( time() - $regdate ) / 86400 ));
$posts_per_day = $profiledata['user_posts'] / $memberdays;

// Get the users percentage of total posts
if ( $profiledata['user_posts'] != 0  )
{
	$total_posts = get_db_stat('postcount');
	$percentage = ( $total_posts ) ? min(100, ($profiledata['user_posts'] / $total_posts) * 100) : 0;
}
else
{
	$percentage = 0;
}
$avatar_img = '';
if ( $profiledata['user_avatar_type'] && $profiledata['user_allowavatar'] )
{
	switch( $profiledata['user_avatar_type'] )
	{
		case USER_AVATAR_UPLOAD:
			$avatar_img = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . '/' . $profiledata['user_avatar'] . '" alt="" border="0" />' : '';
			break;
		case USER_AVATAR_REMOTE:
			$avatar_img = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $profiledata['user_avatar'] . '" alt="" border="0" />' : '';
			break;
		case USER_AVATAR_GALLERY:
			$avatar_img = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $profiledata['user_avatar'] . '" alt="" border="0" />' : '';
			break;
	}
}

$ranks = $datastore->get('ranks');
$poster_rank = $rank_image = '';

// [begin] Warnings Mod 1.0.7
if ( $profiledata['user_warnings'] || $profiledata['user_banned'] )
{
	if ( ( $profiledata['user_warnings'] >= $board_config['warnings_per_ban'] ) || $profiledata['user_banned'] )
	{
		$poster_rank = $lang['Banned_rank'];
		$rank_image =  '<img src="' . $images['user_banned_rank'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" />';

	}
	elseif ( $profiledata['user_warnings'] )
	{
		$poster_rank = sprintf($lang['Warned_rank'], $profiledata['user_warnings']);
		$rank_image =  '<img src="' . $images['user_warned_rank'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" />&nbsp;';
		$rank_image = str_repeat($rank_image, $profiledata['user_warnings']);
	}
	$rank_image .= '<br />'; 

}
else
// [end] Warnings Mod 1.0.7

if ($user_rank = $profiledata['user_rank'] AND isset($ranks[$user_rank]))
{
	$rank_image = ($ranks[$user_rank]['rank_image']) ? '<img src="'. $ranks[$user_rank]['rank_image'] .'" alt="" title="" border="0" />' : '';
	$poster_rank = $ranks[$user_rank]['rank_title'];
}

$temp_url = append_sid("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=" . $profiledata['user_id']);
$pm_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_pm'] . '" alt="' . $lang['Send_private_message'] . '" title="' . $lang['Send_private_message'] . '" border="0" /></a>';

$location = ($profiledata['user_from']) ? $profiledata['user_from'] : '';
$location .= ($profiledata['user_from_flag'] && $profiledata['user_from_flag'] != 'blank.gif') ? '&nbsp;'. make_user_flag($profiledata['user_from_flag']) : '';

$pm = '<a href="' . $temp_url . '">' . $lang['Send_private_message'] . '</a>';

if ( bf($profiledata['user_opt'], 'user_opt', 'viewemail') || IS_ADMIN )
{
	$email_uri = ( $board_config['board_email_form'] ) ? append_sid("profile.$phpEx?mode=email&amp;" . POST_USERS_URL .'=' . $profiledata['user_id']) : 'mailto:' . $profiledata['user_email'];
	$email_img = '<a href="' . $email_uri . '"><img src="' . $images['icon_email'] . '" alt="' . $lang['Send_email'] . '" title="' . $lang['Send_email'] . '" border="0" /></a>';
	$email = '<a href="' . $email_uri . '">' . $lang['Send_email'] . '</a>';
}
else
{
	$email_img = '';
	$email = '';
}
$www_img = ( $profiledata['user_website'] ) ? '<a href="' . $profiledata['user_website'] . '" target="_userwww"><img src="' . $images['icon_www'] . '" alt="' . $lang['Visit_website'] . '" title="' . $lang['Visit_website'] . '" border="0" /></a>' : '';
$www = ( $profiledata['user_website'] ) ? '<a href="' . $profiledata['user_website'] . '" target="_userwww">' . $profiledata['user_website'] . '</a>' : '';
if ( !empty($profiledata['user_icq']) )
{
	$icq_status_img = '<a href="http://wwp.icq.com/' . $profiledata['user_icq'] . '#pager"><img src="http://web.icq.com/whitepages/online?icq=' . $profiledata['user_icq'] . '&img=5" width="18" height="18" border="0" /></a>';
	$icq_img = '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $profiledata['user_icq'] . '"><img src="' . $images['icon_icq'] . '" alt="' . $lang['ICQ'] . '" title="' . $lang['ICQ'] . '" border="0" /></a>';
	$icq =  '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $profiledata['user_icq'] . '">' . $lang['ICQ'] . '</a>';
}
else
{
	$icq_status_img = '';
	$icq_img = '';
	$icq = '';
}
$aim_img = ( $profiledata['user_aim'] ) ? '<a href="aim:goim?screenname=' . $profiledata['user_aim'] . '&amp;message=Hello+Are+you+there?"><img src="' . $images['icon_aim'] . '" alt="' . $lang['AIM'] . '" title="' . $lang['AIM'] . '" border="0" /></a>' : '';
$aim = ( $profiledata['user_aim'] ) ? '<a href="aim:goim?screenname=' . $profiledata['user_aim'] . '&amp;message=Hello+Are+you+there?">' . $lang['AIM'] . '</a>' : '';
$msn_img = ( $profiledata['user_msnm'] ) ? $profiledata['user_msnm'] : '';
$msn = $msn_img;
$yim_img = ( $profiledata['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $profiledata['user_yim'] . '&amp;.src=pg"><img src="' . $images['icon_yim'] . '" alt="' . $lang['YIM'] . '" title="' . $lang['YIM'] . '" border="0" /></a>' : '';
$yim = ( $profiledata['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $profiledata['user_yim'] . '&amp;.src=pg">' . $lang['YIM'] . '</a>' : '';
$temp_url = append_sid("search.$phpEx?search_author=1&amp;uid={$profiledata['user_id']}");
$search_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_search'] . '" alt="' . $lang['Search_user_posts'] . '" title="' . sprintf($lang['Search_user_posts'], $profiledata['username']) . '" border="0" /></a>';
$search = '<a href="' . $temp_url . '">' . sprintf($lang['Search_user_posts'], $profiledata['username']) . '</a>';

// Report
//
// Get report user module and create report link
//
include_once(INC_DIR . "functions_report.$phpEx");
$report_user = report_modules('name', 'report_user');

if ($report_user && $report_user->auth_check('auth_write'))
{
	$template->assign_block_vars('switch_report_user', array());
	$template->assign_vars(array(
		'U_REPORT_USER' => append_sid("report.$phpEx?mode=" . $report_user->mode . '&amp;id=' . $profiledata['user_id']),
		'L_REPORT_USER' => $report_user->lang['Write_report'])
	);
}
// Report [END]

//
// Generate page
//
if ($profiledata['user_id'] == $userdata['user_id'] || IS_ADMIN)
{
	require(BB_ROOT .'attach_mod/attachment_mod.'. PHP_EXT);
	display_upload_attach_box_limits($profiledata['user_id']);
}

$LINK_REG_IP = $LINK_LAST_IP = '';
if (IS_ADMIN || IS_MOD) 
{	
	$sql = "SELECT username, user_id FROM " .USERS_TABLE ." 
			WHERE user_reg_ip = '{$profiledata['user_reg_ip']}' 
				AND user_reg_ip != ''
				AND user_id != {$profiledata['user_id']}
			ORDER BY username ASC";
	$rowset = $db->fetch_rowset($sql);
	if(!empty($rowset))
	{
		$LINK_REG_IP = $lang['reg_ip_users'] ." <table>";
		foreach ($db->fetch_rowset($sql) as $row)
		{
			$LINK_REG_IP .= "<tr>";
			$LINK_REG_IP .= "<td><a href=\"profile.$phpEx?mode=viewprofile&u={$row['user_id']}\">{$row['username']}</a></td>"; 
			$LINK_REG_IP .= "<tr>";
		}
		$LINK_REG_IP .= "</table>";
	}	
	
	$sql = "SELECT username, user_id FROM " .USERS_TABLE ." 
			WHERE user_last_ip = '{$profiledata['user_last_ip']}' 
				AND user_last_ip != ''
				AND user_id != {$profiledata['user_id']}";
	$rowset = $db->fetch_rowset($sql);
	if(!empty($rowset))
	{
		$LINK_LAST_IP .= $lang['last_ip_users'] ." <table>";
		foreach ($rowset as $row)
		{
			$LINK_LAST_IP .= "<tr>";
			$LINK_LAST_IP .= "<td><a href=\"profile.$phpEx?mode=viewprofile&u={$row['user_id']}\">{$row['username']}</a></td>"; 
			$LINK_LAST_IP .= "<tr>"; 
		}
		$LINK_LAST_IP .= "</table>";
	}
}

// User group
$user_id = $userdata['user_id'];
$view_user_id = $profiledata['user_id'];
$groups = array();
$sql = '
   SELECT
      g.group_id,
      g.group_name,
      g.group_type
   FROM
      '.USER_GROUP_TABLE.' as l,
      '.GROUPS_TABLE.' as g
   WHERE
      l.user_pending = 0 AND
      g.group_single_user = 0 AND
      l.user_id ='. $view_user_id.' AND
      g.group_id = l.group_id
   ORDER BY
      g.group_name,
      g.group_id';
if ( !($result = $db->sql_query($sql)) ) message_die(GENERAL_ERROR, 'Could not read groups', '', __LINE__, __FILE__, $sql);   
while ($group = $db->sql_fetchrow($result)) $groups[] = $group;

$template->assign_vars(array(
   'L_USERGROUPS' => $lang['USERGROUPS'],
   )
);
if (count($groups) > 0)
{
$groupsw=TRUE;
   for ($i=0; $i < count($groups); $i++)
   {
      $is_ok = false;
      //
      // groupe invisible ?
      if ( ($groups[$i]['group_type'] != GROUP_HIDDEN) || ($userdata['user_level'] == ADMIN) )
      {
         $is_ok=true;
      }
      else
      {
         $group_id = $groups[$i]['group_id'];
         $sql = 'SELECT * FROM '.USER_GROUP_TABLE.' WHERE group_id='.$group_id.' AND user_id='.$user_id.' AND user_pending=0';
         if ( !($result = $db->sql_query($sql)) ) message_die(GENERAL_ERROR, 'Couldn\'t obtain viewer group list', '', __LINE__, __FILE__, $sql);
         $is_ok = ( $group = $db->sql_fetchrow($result) );
      }  // end if ($view_list[$i]['group_type'] == GROUP_HIDDEN)
      //
      // groupe visible : afficher
      if ($is_ok)
      {
         $u_group_name = append_sid("groupcp.php?g=".$groups[$i]['group_id']);
         $l_group_name = $groups[$i]['group_name'];
         $template->assign_block_vars('groups',array(
            'U_GROUP_NAME' => $u_group_name,
            'L_GROUP_NAME' => $l_group_name,
            )
         );
      }  // end if ($is_ok)
   }  // end for ($i=0; $i < count($groups); $i++)
}  // end if (count($groups) > 0)
else
{
$groupsw = false;
}
//user group#

if ( $profiledata['user_readonly'] != 0 )
   {
   $user_ro = '<i class="leech"></i>';
   }
   else
   {
   $user_ro = '<i class="seed"></i>';
   }

$template->assign_vars(array(
	'PAGE_TITLE' 	=> $lang['Viewing_profile'],
	'USERNAME' 		=> $profiledata['username'],
	'USER_RO'   => $user_ro,
	'PROFILE_USER_ID' => $profiledata['user_id'],
	'USER_REGDATE' 	=> bb_date($profiledata['user_regdate']),
	'POSTER_RANK' 	=> $poster_rank,
	'RANK_IMAGE' 	=> $rank_image,
	'POSTS_PER_DAY' => $posts_per_day,
	'POSTS' 		=> $profiledata['user_posts'],
	'PERCENTAGE' 	=> $percentage . '%',
	'POST_DAY_STATS' => sprintf($lang['User_post_day_stats'], $posts_per_day),
	'POST_PERCENT_STATS' => sprintf($lang['User_post_pct_stats'], $percentage),
	'SEARCH_IMG' => $search_img,
	'SEARCH' 	=> $search,
	'PM_IMG' 	=> $pm_img,
	'PM' 		=> $pm,
	'EMAIL_IMG' => $email_img,
	'EMAIL' 	=> $email,
	'WWW_IMG' 	=> $www_img,
	'GROUPSW'	=> $groupsw,
	'WWW' 		=> $www,
	'ICQ_STATUS_IMG' => $icq_status_img,
	'ICQ_IMG' 	=> $icq_img,
	'ICQ' 		=> $icq,
	'AIM_IMG' 	=> $aim_img,
	'AIM' 		=> $aim,
	'MSN_IMG' 	=> $msn_img,
	'MSN' 		=> $msn,
	'YIM_IMG' 	=> $yim_img,
	'YIM' 		=> $yim,
	'LAST_VISIT_TIME' => ($profiledata['user_lastvisit']) ? bb_date($profiledata['user_lastvisit']) : $lang['Never'],
	'LAST_ACTIVITY_TIME' => ($profiledata['user_session_time']) ? bb_date($profiledata['user_session_time']) : $lang['Never'],
	'LOCATION' => $location,
	
	'REG_IP'    => '<b>'. decode_ip($profiledata['user_reg_ip']). '</b>',
	'LAST_IP'   => '<b>'. decode_ip($profiledata['user_last_ip']). '</b>',
	'L_REG_IP'  => $lang['reg_ip'],
	'L_LAST_IP' => $lang['last_ip'],	
	'LINK_REG_IP'  => $LINK_REG_IP,
	'LINK_LAST_IP' => $LINK_LAST_IP,

	'USER_ACTIVE' 	=> $profiledata['user_active'],

	'OCCUPATION' 	=> ( $profiledata['user_occ'] ) ? $profiledata['user_occ'] : '',
	'INTERESTS' 	=> ( $profiledata['user_interests'] ) ? $profiledata['user_interests'] : '',
	'AVATAR_IMG' 	=> $avatar_img,

	'L_VIEWING_PROFILE' => sprintf($lang['Viewing_user_profile'], $profiledata['username']),
	'L_ABOUT_USER' 	=> sprintf($lang['About_user'], $profiledata['username']),
	'L_AVATAR' 		=> $lang['Avatar'],
	'L_POSTER_RANK' => $lang['Poster_rank'],
	'L_TOTAL_POSTS' => $lang['Total_posts'],
	'L_SEARCH_USER_POSTS' => sprintf($lang['Search_user_posts'], '<b>'. $profiledata['username'] .'</b>'),
	'L_CONTACT' 	=> $lang['Contact'],
	'L_EMAIL_ADDRESS' => $lang['Email_address'],
	'L_OCCUPATION' 	=> $lang['Occupation'],
	'L_INTERESTS' 	=> $lang['Interests'],

	'U_SEARCH_USER'     => "search.$phpEx?search_author=1&amp;uid={$profiledata['user_id']}",
	'U_SEARCH_RELEASES' => "tracker.$phpEx?rid={$profiledata['user_id']}#results",
	'L_SEARCH_RELEASES' => $lang['Search_user_releases'],

	'S_PROFILE_ACTION'  => "profile.$phpEx",
));

//bt
// Show users torrent-profile

// [begin] Warnings Mod 1.0.7
$sql = "SELECT w.*, wt.*, u.username FROM " . WARNINGS_TABLE . " w, " . WARNINGS_TEXT_TABLE . " wt, " . USERS_TABLE . " u WHERE w.warning_user_id = '" . $profiledata['user_id'] . "' AND wt.warning_id = w.warning_id AND u.user_id = w.warning_poster_id";
if ( !in_array($userdata['user_level'], array(ADMIN,MOD)) )
{
	$sql .= " AND (w.warning_expires > " . time() . " OR w.warning_expires = " . WARNING_INFINITY . ')';
}
$sql .= " ORDER BY w.warning_proceed ASC, w.warning_posted DESC";
$result = $db->sql_query($sql) or message_die(GENERAL_ERROR, 'Could not insert warning information', '', __LINE__, __FILE__, $sql);

if ( $db->sql_numrows($result) )
{
	$template->set_filenames(array(
		'warnings_profile_view_body' => 'warnings_profile_view_body.tpl')
	);

	$template->assign_block_vars('switch_warnings', array());

	$template->assign_vars(array(
		'L_WARNINGS' => $lang['Warnings'],
		'L_WARNING_TEXT_CAPTION' => $lang['Warning_text_caption'],
		'L_WARNING_POSTER' => $lang['Warning_poster'],
		'L_WARNING_EXPIRES' => $lang['Warning_expires'],
		'L_WARNING_ACTIONS' => $lang['Warning_actions'],
		'L_EXPIRED_WARNINGS' => $lang['Expired_warnings']
		)
	);

	$i = 1;
	$previous_warning_proceed = 0;
	$warning_actions_flag = FALSE;

	while ( $row = $db->sql_fetchrow($result) )
	{
		switch ( $row['warning_type'] )
		{
			case WARNING_TYPE_WARNING:
				$warning_icon = $images['user_warned_rank'];
			break;
					
			case WARNING_TYPE_BAN:
				$warning_icon = $images['user_banned_rank'];
			break;
		}
			
		$warning_icon = '<img src="' . $warning_icon . '" border="0" alt="">';
		$warning_text = htmlspecialchars($row['warning_text']);
		$warning_post = '<a class="gensmall" href="' . append_sid('viewtopic.' . $phpEx . '?' . POST_POST_URL . '=' . $row['warning_post_id']) . '#' . $row['warning_post_id'] . '">' . $lang['Warned_post_link'] . '</a>';
		$warning_poster = '<a class="gensmall" href="' . append_sid('profile.' . $phpEx . '?mode=viewprofile&amp;' . POST_USERS_URL . '=' . $row['warning_poster_id']) . '">' . $row['username'] . '</a>';
		$warning_posted = create_date($board_config['default_dateformat'], $row['warning_posted'], $board_config['board_timezone']);
		$warning_expires = ( $row['warning_expires'] != WARNING_INFINITY ) ? create_date($board_config['default_dateformat'], $row['warning_expires'], $board_config['board_timezone']) : $lang['wt_infinity'];

		if ( $row['warning_proceed'] && !$previous_warning_proceed )
		{
			$i = 1;
		}

		$template->assign_block_vars('warning_row', array(
			'WARNING_NUMBER' => $i,
			'WARNING_ICON' => $warning_icon,
			'WARNING_TEXT' => $warning_text,
			'WARNING_POST' => $warning_post,
			'WARNING_POSTER' => $warning_poster,
			'WARNING_POSTED' => $warning_posted,
			'WARNING_EXPIRES' => $warning_expires
			)
		);

		if ( $row['warning_proceed'] && !$previous_warning_proceed )
		{
			$template->assign_block_vars('warning_row.proceed_separator', array());
		}

		if ( ( $row['warning_poster_id'] == $userdata['user_id'] ) || ( $userdata['user_level'] == ADMIN ) )
		{
			$warning_actions_flag = TRUE;

			$warning_actions = array();
			$warning_actions[] = '<a class="gensmall" href="warnings.' . $phpEx . '?mode=edit_warning&amp;' . POST_WARNING_URL . '=' . $row['warning_id'] . '&amp;sid=' . $userdata['session_id'] . '">' . $lang['Edit_warning'] . '</a>';
			if ( !$row['warning_proceed'] )
			{
				$warning_actions[] = '<a class="gensmall" href="warnings.' . $phpEx . '?mode=remove_warning&amp;' . POST_WARNING_URL . '=' . $row['warning_id'] . '&amp;sid=' . $userdata['session_id'] . '">' . $lang['Remove_warning'] . '</a>';
			}
			$warning_actions[] = '<a class="gensmall" href="warnings.' . $phpEx . '?mode=delete_warning&amp;' . POST_WARNING_URL . '=' . $row['warning_id'] . '&amp;sid=' . $userdata['session_id'] . '">' . $lang['Delete_warning'] . '</a>';

			$template->assign_block_vars('warning_row.actions', array(
				'WARNING_ACTIONS' => implode($warning_actions, '<br />')
				)
			);
		}

		$i++;
		$previous_warning_proceed = $row['warning_proceed'];
	}

	if ( $warning_actions_flag )
	{
		$template->assign_block_vars('warning_actions_header', array());
	}

	if ( ( $profiledata['user_warnings'] >= $board_config['warnings_per_ban'] ) || 	$profiledata['user_banned'] )
	{
		if ( $profiledata['user_banned'] )
		{
			$warning_type = WARNING_TYPE_BAN;
			$warning_lang = 'User_banned_ban';
		}
		else
		{
			$warning_type = WARNING_TYPE_WARNING;
			$warning_lang = 'User_banned_warnings';
		}

		$sql = "SELECT * FROM " . WARNINGS_TABLE . " WHERE warning_user_id = " . $profiledata['user_id'] . " AND warning_proceed = 0 AND warning_expires != " . WARNING_INFINITY . " AND warning_type = '$warning_type' ORDER BY warning_expires ASC LIMIT 1";
		$result = $db->sql_query($sql) or message_die(GENERAL_ERROR, 'Could not get warning information', '', __LINE__, __FILE__, $sql);

		if ( $db->sql_numrows($result) )
		{
			$row = $db->sql_fetchrow($result);
			$unban_time = create_date($board_config['default_dateformat'], $row['warning_expires'], $board_config['board_timezone']);
			$warning_lang = sprintf($lang[$warning_lang], $unban_time);
		}
		else
		{
			$warning_lang = $lang['User_banned'];
		}

		$template->assign_block_vars('switch_banned', array());

		$template->assign_vars(array(
			'BANNED' => $warning_lang
			)
		);
	}

	$template->assign_var_from_handle('WARNINGS', 'warnings_profile_view_body');
}
// [end] Warnings Mod 1.0.7

define('IN_VIEWPROFILE', TRUE);
include(INC_DIR .'ucp/torrent_userprofile.'. $phpEx);
//bt end

$template->assign_vars(array(
	'SHOW_ACCESS_PRIVILEGE' => IS_ADMIN,
	'L_ACCESS'              => $lang['Access'],
	'L_ACCESS_SRV_LOAD'     => $lang['Access_srv_load'],
	'IGNORE_SRV_LOAD'       => ($profiledata['user_level'] != USER || $profiledata['ignore_srv_load']) ? $lang['NO'] : $lang['YES'],
	'IGNORE_SRV_LOAD_EDIT'  => ($profiledata['user_level'] == USER),
));

if (IS_ADMIN)
{
	$template->assign_vars(array(
		'EDITABLE_TPLS' => true,

		'U_MANAGE'      => "admin/admin_users.$phpEx?mode=edit&amp;u={$profiledata['user_id']}",
		'U_PERMISSIONS' => "admin/admin_ug_auth.$phpEx?mode=user&amp;u={$profiledata['user_id']}",

		'L_MANAGE'      => 'Profile',
		'L_PERMISSIONS' => 'Permissions',
	));
}

print_page('usercp_viewprofile.tpl');
