<?php

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/


$unhtml_specialchars_match = array('#&gt;#', '#&lt;#', '#&quot;#', '#&amp;#');
$unhtml_specialchars_replace = array('>', '<', '"', '&');

define('IN_PHPBB', true);
define('BEGIN_TRANSACTION', 1);
define('END_TRANSACTION', 2);

$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
//include($phpbb_root_path . 'warnings_common.'.$phpEx);


global $lang;

$add_warning = ( isset($HTTP_POST_VARS['add_warning']) || isset($HTTP_GET_VARS['add_warning']) );
$delete_warning = ( isset($HTTP_POST_VARS['delete_warning']) || isset($HTTP_GET_VARS['delete_warning']) );

if ( isset($HTTP_GET_VARS[POST_POST_URL]) || isset($HTTP_POST_VARS[POST_POST_URL]) )
{
	$post_id = (isset($HTTP_POST_VARS[POST_POST_URL])) ? intval($HTTP_POST_VARS[POST_POST_URL]) : intval($HTTP_GET_VARS[POST_POST_URL]);
}
else
{
	$post_id = '';
}

if ( isset($HTTP_GET_VARS[POST_WARNING_URL]) || isset($HTTP_POST_VARS[POST_WARNING_URL]) )
{
	$warning_id = (isset($HTTP_POST_VARS[POST_WARNING_URL])) ? intval($HTTP_POST_VARS[POST_WARNING_URL]) : intval($HTTP_GET_VARS[POST_WARNING_URL]);
}
else
{
	$warning_id = '';
}

$confirm = (isset($_POST["confirm"])) ? TRUE : 0;

if ( isset($HTTP_POST_VARS['mode']) || isset($HTTP_GET_VARS['mode']) )
{
	$mode = ( isset($HTTP_POST_VARS['mode']) ) ? $HTTP_POST_VARS['mode'] : $HTTP_GET_VARS['mode'];
	$mode = htmlspecialchars($mode);
}
else
{
		$mode = '';
}

if (!empty($HTTP_POST_VARS['sid']) || !empty($HTTP_GET_VARS['sid']))
{
	$sid = (!empty($HTTP_POST_VARS['sid'])) ? $HTTP_POST_VARS['sid'] : $HTTP_GET_VARS['sid'];
}
else
{
	$sid = '';
}

//
// Set default email variables
//
$script_name = preg_replace('/^\/?(.*?)\/?$/', '\1', trim($board_config['script_path']));
$script_name = ( $script_name != '' ) ? $script_name . '/viewtopic.'.$phpEx : 'viewtopic.'.$phpEx;
$server_name = trim($board_config['server_name']);
$server_protocol = ( $board_config['cookie_secure'] ) ? 'https://' : 'http://';
$server_port = ( $board_config['server_port'] <> 80 ) ? ':' . trim($board_config['server_port']) . '/' : '/';

$server_url = $server_protocol . $server_name . $server_port . $script_name;

//
// Start session management
//

// Start session
$user->session_start();

//$userdata = session_pagestart($user_ip);
//init_userprefs($userdata);
//
// End session management
//

// session id check
if ($sid == '' || $sid != $userdata['session_id'])
{
	message_die(GENERAL_ERROR, 'Invalid_session');
}

//
// Check if user did or did not confirm
// If they did not, forward them to the last page they were on
//
if ( isset($HTTP_POST_VARS['cancel']) )
{
	if ( $post_id )
	{
		$redirect = "viewtopic.$phpEx?" . POST_POST_URL . "=$post_id";
	}
	else
	{
		$redirect = "index.$phpEx";
	}

	redirect(append_sid($redirect, true));
}

//
// Do major work ...
//
switch( $mode )
{
	case 'add_warning':
		$page_title = 'Warnings_CP';
		include($phpbb_root_path . 'includes/page_header.'.$phpEx);


		if ( !empty($post_id) )
		{
			$sql = "SELECT t.forum_id, p.poster_id FROM " . TOPICS_TABLE . " t, " . POSTS_TABLE . " p WHERE t.topic_id = p.topic_id AND p.post_id = " . $post_id;
			$result = $db->sql_query($sql) or message_die(GENERAL_MESSAGE, 'Topic_post_not_exist');
			$row = $db->sql_fetchrow($result) or message_die(GENERAL_MESSAGE, 'Topic_post_not_exist');

			$forum_id = $row['forum_id'];
			$user_id = $row['poster_id'];
		}
		else
		{
			message_die(GENERAL_MESSAGE, 'Topic_post_not_exist');
		}

		//
		// Start auth check
		//
		$is_auth = auth(AUTH_ALL, $forum_id, $userdata);

		if ( !$is_auth['auth_mod'] )
		{
			message_die(GENERAL_MESSAGE, $lang['Not_Moderator'], $lang['Not_Authorised']);
		}
		//
		// End Auth Check
		//

		if ( $user_id == ANONYMOUS )
		{
			message_die(GENERAL_ERROR, 'No_warning_for_user');
		}

		$sql = "SELECT * FROM " . USERS_TABLE . " WHERE user_id='$user_id'";
		$result = $db->sql_query($sql) or	message_die(GENERAL_ERROR, 'Could not insert warning information', '', __LINE__, __FILE__, $sql);
		$row = $db->sql_fetchrow($result) or message_die(GENERAL_MESSAGE, 'User_not_exist');

		if ( in_array($row['user_level'], array(ADMIN,MOD)) )
		{
			message_die(GENERAL_ERROR, 'No_warning_for_user');
		}

		if ( $row['user_banned'] )
		{
			message_die(GENERAL_ERROR, 'Ban_received_for_this_post');
		}

		if ( $userdata['user_level'] != ADMIN )
		{
			$sql = "SELECT * FROM " . WARNINGS_TABLE . " WHERE warning_post_id = '$post_id'";
			$result = $db->sql_query($sql) or message_die(GENERAL_ERROR, 'Could not get warning information', '', __LINE__, __FILE__, $sql);

			if ( $db->sql_numrows($result) )
			{
				$check_row = $db->sql_fetchrow($result)  or message_die(GENERAL_ERROR, 'Could not get warning information');

				if ( $check_row['warning_poster_id'] != $userdata['user_id'] )
				{
					message_die(GENERAL_MESSAGE, 'Warning_received_for_this_post');
				}

			}
		}

		if ( $row['user_warnings'] >= $board_config['warnings_per_ban'] )
		{
			message_die(GENERAL_ERROR, 'Warnings_limit_reached');
		}

		if ( isset($HTTP_POST_VARS['add_warning']) )
		{
			$warning_type = isset($HTTP_POST_VARS['warning_type']) ? intval($HTTP_POST_VARS['warning_type']) : 0;
			$warning_time = isset($HTTP_POST_VARS['warning_time']) ? intval($HTTP_POST_VARS['warning_time']) : 0;
			$warning_text = isset($HTTP_POST_VARS['warning_text']) ? $HTTP_POST_VARS['warning_text'] : '';

 			if ( empty($warning_type) || empty($warning_time) || empty($warning_text) )
 			{
 				message_die(GENERAL_MESSAGE, 'Warnings_not_enough_params');
 			}

 			if ( ( ( $warning_time < 0 ) && ( $warning_time != WARNING_INFINITY ) ) || !in_array($warning_type, array(WARNING_TYPE_WARNING, WARNING_TYPE_BAN)) )
 			{
 				message_die(GENERAL_MESSAGE, 'Warnings_wrong_params');
 			}
 			$sql = "SELECT w.*, wt.* FROM " .  WARNINGS_TABLE . " w, " . WARNINGS_TEXT_TABLE . " wt WHERE w.warning_user_id = '$user_id' AND wt.warning_id = w.warning_id ORDER BY w.warning_posted DESC LIMIT 1";
			$result = $db->sql_query($sql) or	message_die(GENERAL_ERROR, 'Could not check warning information', '', __LINE__, __FILE__, $sql);

			if ( $db->sql_numrows($result) )
			{
				$check_row = $db->sql_fetchrow($result) or message_die(GENERAL_MESSAGE, 'Error checking warning information');
				$check_time = ( $check_row['warning_expires'] != WARNING_INFINITY ) ? $check_row['warning_expires'] - $check_row['warning_posted'] : $check_row['warning_expires'];
				$check_text = stripslashes($warning_text);

				if (
					( $check_row['warning_type'] == $warning_type ) &&
					( $check_row['warning_post_id'] == $post_id ) &&
					( $check_row['warning_user_id'] == $user_id ) &&
					( $check_row['warning_poster_id'] == $userdata['user_id'] ) &&
					( $check_time == $warning_time ) &&
					( $check_row['warning_text'] == $check_text )
					)
					{
						message_die(GENERAL_MESSAGE, 'Warning_with_this_data_already_given');
					}
			}



 			$current_time = time();
 			$warning_expires = ( $warning_time != WARNING_INFINITY ) ? $current_time + $warning_time : $warning_time;

			$sql = "INSERT INTO " . WARNINGS_TABLE . " (warning_id, warning_type, warning_post_id, warning_user_id, warning_poster_id, warning_posted, warning_expires) VALUES('', '$warning_type', '$post_id', '$user_id', '" . $userdata['user_id'] . "', '$current_time', '$warning_expires')";
			$db->sql_query($sql, BEGIN_TRANSACTION) or message_die(GENERAL_ERROR, 'Could not insert warning information', '', __LINE__, __FILE__, $sql);

			$warning_id = $db->sql_nextid();
			$bbcode_uid = '';
			$warning_text = str_replace("\'", "''", $warning_text);

			$sql = "INSERT INTO " . WARNINGS_TEXT_TABLE . " (warning_id, bbcode_uid, warning_text) VALUES('$warning_id', '$bbcode_uid', '$warning_text')";
			$db->sql_query($sql) or	message_die(GENERAL_ERROR, 'Could not insert warning information', '', __LINE__, __FILE__, $sql);

			if ( ( $warning_type >= WARNING_TYPE_WARNING && ($row['user_warnings'] + 1) == $board_config['warnings_per_ban'] ) || ( $warning_type == WARNING_TYPE_BAN ) )
			{
				$sql = "DELETE FROM " . SESSIONS_TABLE . " WHERE session_user_id = " . $user_id;
				$db->sql_query($sql) or message_die(GENERAL_ERROR, 'Could not update session information', '', __LINE__, __FILE__, $sql);
			}

			switch ( $warning_type )
			{
				case WARNING_TYPE_WARNING:
					$sql = "UPDATE " . USERS_TABLE . " SET user_warnings = user_warnings + 1 WHERE user_id = '$user_id'";
					break;

				case WARNING_TYPE_BAN:
					$sql = "UPDATE " . USERS_TABLE . " SET user_banned = 1 WHERE user_id = '$user_id'";
					break;
			}

			$db->sql_query($sql, END_TRANSACTION) or message_die(GENERAL_ERROR, 'Could not update user warnings/ban information', '', __LINE__, __FILE__, $sql);

			switch ( $warning_type )
			{
				case WARNING_TYPE_WARNING:
					$email_template = 'warnings_warning';
					$email_subject = $lang['You_received_warning'];
				break;

				case WARNING_TYPE_BAN:
					$email_template = 'warnings_ban';
					$email_subject = $lang['You_received_ban'];
				break;
			}
			
			$email_now_warnings =  ( $warning_type == WARNING_TYPE_WARNING ) ? ($row['user_warnings'] + 1) : $row['user_warnings'];
			$email_warning_expires =  ( $warning_expires == WARNING_INFINITY ) ? $lang['wt_infinity'] : create_date($row['user_dateformat'], $warning_expires, $row['user_timezone']);
			if ( $warning_type == WARNING_TYPE_WARNING && ($row['user_warnings'] + 1) < $board_config['warnings_per_ban'] )
			{
				$warnings_information = sprintf($lang['Total_warn'], $email_now_warnings, $board_config['warnings_per_ban']);
			}
			else
			{
				$warnings_information = '';
			}

			include($phpbb_root_path . 'includes/emailer.'.$phpEx);
			$emailer = new emailer($board_config['smtp_delivery']);

			$emailer->from($board_config['board_email']);
			$emailer->replyto($board_config['board_email']);
			$emailer->use_template($email_template, stripslashes($row['user_lang']));
			$emailer->email_address($row['user_email']);
			$emailer->set_subject(sprintf($email_subject, $board_config['sitename']));

			$emailer->assign_vars(array(
				'SITENAME' => $board_config['sitename'],
				'EMAIL_SIG' => (!empty($board_config['board_email_sig'])) ? str_replace('<br />', "\n", "-- \n" . $board_config['board_email_sig']) : '',
				'USERNAME' => preg_replace($unhtml_specialchars_match, $unhtml_specialchars_replace, substr(str_replace("\'", "'", $row['username']), 0, 25)),
				'POST_URL' => $server_url . '?' . POST_POST_URL . '=' . $post_id . '#' . $post_id,
				'WARNING_REASON' => $warning_text,
				'WARNING_EXPIRES' => $email_warning_expires,
				'WARNINGS_INFORMATION' => $warnings_information,
				'WARNINGS' => $lang['WARNINGS'],
				'TOTAL_WARN' => $lang['TOTAL_WARNS'],
				'WARNER' => $userdata['username']
				)
			);

			$emailer->send();
			$emailer->reset();

			if ( $warning_type >= WARNING_TYPE_WARNING && ($row['user_warnings'] + 1) == $board_config['warnings_per_ban'] )
			{
				$sql = "SELECT * FROM " . WARNINGS_TABLE . " WHERE warning_user_id = " . $user_id . " AND warning_proceed = 0 AND warning_expires != " . WARNING_INFINITY . " AND warning_type = '" . WARNING_TYPE_WARNING . "' ORDER BY warning_expires ASC LIMIT 1";
				$result = $db->sql_query($sql) or message_die(GENERAL_ERROR, 'Could not get warning information', '', __LINE__, __FILE__, $sql);

				if ( $db->sql_numrows($result) )
				{
					$warning_row = $db->sql_fetchrow($result);
					$email_warning_expires = create_date($row['user_dateformat'], $warning_row['warning_expires'], $row['user_timezone']);
				}
				else
				{
					$email_warning_expires = $lang['wt_infinity'];
				}

				$emailer->from($board_config['board_email']);
				$emailer->replyto($board_config['board_email']);

				$emailer->use_template('warnings_ban_by_warnings', stripslashes($row['user_lang']));
				$emailer->email_address($row['user_email']);
				$emailer->set_subject( sprintf($lang['You_received_ban'], $board_config['sitename']));

				$emailer->assign_vars(array(
					'SITENAME' => $board_config['sitename'],
					'EMAIL_SIG' => (!empty($board_config['board_email_sig'])) ? str_replace('<br />', "\n", "-- \n" . $board_config['board_email_sig']) : '',
					'USERNAME' => preg_replace($unhtml_specialchars_match, $unhtml_specialchars_replace, substr(str_replace("\'", "'", $row['username']), 0, 25)),
					'WARNING_EXPIRES' => $email_warning_expires
					)
				);

				$emailer->send();
				$emailer->reset();
			}

			$redirect = append_sid('viewtopic.' . $phpEx . '?' . POST_POST_URL . '=' . $post_id);
			$l_redirect = sprintf($lang['Click_return_topic'], '<a href="' . $redirect . '">', '</a>');

			$template->assign_vars(array(
				'META' => '<meta http-equiv="refresh" content="3;url=' . $redirect . '">')
			);

			message_die(GENERAL_MESSAGE, $lang['Warning_successfully_added'] . '<br /><br />' . $l_redirect);
		}
		else
		{
			//
			// Set template files
			//
			$template->set_filenames(array(
				'body' => 'warnings_posting_body.tpl')
			);

			$hidden_fields = '<input type="hidden" name="sid" value="' . $userdata['session_id'] . '" /><input type="hidden" name="' . POST_POST_URL . '" value="' . $post_id . '"><input type="hidden" name="mode" value="' . $mode . '" />';

			$warning_time_values = array(1, 3, 5, 7, 14, 30);

			$warning_time_select = '<select name="warning_time">';
			
			$warning_time_select .= '<option value="' . WARNING_INFINITY . '">' . $lang['wt_infinity'] . '</option>';

			for($i = 0; $i < count($warning_time_values); $i++)
			{
				$warning_time_select .= '<option value="' . ($warning_time_values[$i] * 86400) . '">' . $lang['wt_' . $warning_time_values[$i]] . '</option>';
			}
			$warning_time_select .= '</select>';

			$template->assign_vars(array(
				'L_WARN_USER' => $lang['Warn_user'],
				'L_WARNING_TYPE' => $lang['Warning_type'],
				'L_WARNING_TYPE_WARNING' => $lang['Warning_type_warning'],
				'L_WARNING_TYPE_BAN' => $lang['Warning_type_ban'],
				'L_WARNING_TIME'=> $lang['Warning_time'],
				'L_WARNING_TEXT' => $lang['Warning_text'],
				'L_CANCEL' => '',

				'WARNING_TYPE_1_CHECKED' => 'checked="checked"',
				'WARNING_TYPE_2_CHECKED' => '',
				'WARNING_TEXT' => '',

				'S_WARNING_TIME' => $warning_time_select,
				'S_WARNING_ACTION' => append_sid("warnings.$phpEx"),
				'S_HIDDEN_FIELDS' => $hidden_fields)
			);

			$template->pparse('body');

			include($phpbb_root_path . 'includes/page_footer.'.$phpEx);
		}
		break;


	case 'edit_warning':
		$page_title = $lang['Warnings_CP'];
		include($phpbb_root_path . 'includes/page_header.'.$phpEx);

		//
		// Start auth check
		//
		if ( !in_array($userdata['user_level'], array(ADMIN,MOD)) )
		{
			message_die(GENERAL_MESSAGE, $lang['Not_Moderator'], $lang['Not_Authorised']);
		}
		//
		// End Auth Check
		//

		$sql = "SELECT w.*, wt.*, u.* FROM " . WARNINGS_TABLE . " w, " . WARNINGS_TEXT_TABLE . " wt, " . USERS_TABLE . " u WHERE w.warning_id = '$warning_id' AND wt.warning_id = w.warning_id AND u.user_id = w.warning_user_id";
		$result = $db->sql_query($sql) or message_die(GENERAL_ERROR, 'Could not get warning information', '', __LINE__, __FILE__, $sql);
		$row = $db->sql_fetchrow($result)  or message_die(GENERAL_ERROR, 'Could not get warning information');

		$user_id = $row['warning_user_id'];
		$post_id = $row['warning_post_id'];

		if ( $userdata['user_level'] != ADMIN )
		{
			if ( $row['warning_poster_id'] != $userdata['user_id'] )
			{
				message_die(GENERAL_MESSAGE, 'Warning_cannot_process_not_yours');
			}
		}

		if ( isset($HTTP_POST_VARS['add_warning']) )
		{
			$warning_type = isset($HTTP_POST_VARS['warning_type']) ? intval($HTTP_POST_VARS['warning_type']) : 0;
			$warning_time = isset($HTTP_POST_VARS['warning_time']) ? intval($HTTP_POST_VARS['warning_time']) : 0;
			$warning_text = isset($HTTP_POST_VARS['warning_text']) ? $HTTP_POST_VARS['warning_text'] : '';

 			if ( empty($warning_type) || empty($warning_time) || empty($warning_text) )
 			{
 				message_die(GENERAL_MESSAGE, 'Warnings_not_enough_params');
 			}

 			if ( ( ( $warning_time < 0 ) && ( $warning_time != WARNING_INFINITY ) ) || !in_array($warning_type, array(WARNING_TYPE_WARNING, WARNING_TYPE_BAN)) )
 			{
 				message_die(GENERAL_MESSAGE, 'Warnings_wrong_params');
 			}
 			

 			$warning_expires = ( $warning_time != WARNING_INFINITY ) ? $row['warning_posted'] + $warning_time : $warning_time;
			$warning_text = str_replace("\'", "''", $warning_text);

			$sql = "UPDATE " . WARNINGS_TABLE . " SET warning_type = '$warning_type', warning_expires = '$warning_expires' WHERE warning_id = '$warning_id'";
			$db->sql_query($sql, BEGIN_TRANSACTION) or message_die(GENERAL_ERROR, 'Could not update warning information', '', __LINE__, __FILE__, $sql);

			if ( $warning_type == WARNING_TYPE_BAN )
			{
				$sql = "DELETE FROM " . SESSIONS_TABLE . " WHERE session_user_id = " . $user_id;
				$db->sql_query($sql) or message_die(GENERAL_ERROR, 'Could not update session information', '', __LINE__, __FILE__, $sql);
			}

			if ( $row['warning_type'] != $warning_type )
			{
				switch ( $row['warning_type'] )
				{
					case WARNING_TYPE_WARNING:
						$sql = "UPDATE " . USERS_TABLE . " SET user_warnings = user_warnings - 1 WHERE user_id = '$user_id'";
					break;

					case WARNING_TYPE_BAN:
						$sql = "UPDATE " . USERS_TABLE . " SET user_banned = 0 WHERE user_id = '$user_id'";
					break;
				}

				$db->sql_query($sql) or message_die(GENERAL_ERROR, 'Could not update user information', '', __LINE__, __FILE__, $sql);

				switch ( $warning_type )
				{
					case WARNING_TYPE_WARNING:
						$sql = "UPDATE " . USERS_TABLE . " SET user_warnings = user_warnings + 1 WHERE user_id = '$user_id'";
					break;

					case WARNING_TYPE_BAN:
						$sql = "UPDATE " . USERS_TABLE . " SET user_banned = 1 WHERE user_id = '$user_id'";
					break;
				}


				$db->sql_query($sql) or message_die(GENERAL_ERROR, 'Could not update user information', '', __LINE__, __FILE__, $sql);

				$email_template = 'warnings_type_changed';

				switch ( $warning_type )
				{
					case WARNING_TYPE_WARNING:
						$email_subject = $lang['You_received_warning'];
						$email_change_text = $lang['Ban_changed_to_warning'];
					break;

					case WARNING_TYPE_BAN:
						$email_subject = $lang['You_received_ban'];
						$email_change_text = $lang['Warning_changed_to_ban'];
					break;
				}

				$lang_key = 'Warning_type_changed_' . $row['warning_type'] . $warning_type;
				$email_change_text = $lang[$lang_key];


				include($phpbb_root_path . 'includes/emailer.'.$phpEx);
				$emailer = new emailer($board_config['smtp_delivery']);

				$emailer->from($board_config['board_email']);
				$emailer->replyto($board_config['board_email']);

				$emailer->use_template($email_template, stripslashes($row['user_lang']));
				$emailer->email_address($row['user_email']);
				$emailer->set_subject(sprintf($email_subject, $board_config['sitename']));

				$emailer->assign_vars(array(
					'SITENAME' => $board_config['sitename'],
					'EMAIL_SIG' => (!empty($board_config['board_email_sig'])) ? str_replace('<br />', "\n", "-- \n" . $board_config['board_email_sig']) : '',
					'USERNAME' => preg_replace($unhtml_specialchars_match, $unhtml_specialchars_replace, substr(str_replace("\'", "'", $row['username']), 0, 25)),
					'POST_URL' => $server_url . '?' . POST_POST_URL . '=' . $post_id . '#' . $post_id,
					'WARNING_SUBJECT' => sprintf($email_subject, $board_config['sitename']),
					'WARNING_CHANGE_TEXT' => $email_change_text
					)
				);

				$emailer->send();
				$emailer->reset();
			}

			$sql = "UPDATE " . WARNINGS_TEXT_TABLE . " SET warning_text = '$warning_text' WHERE warning_id = '$warning_id'";
			$db->sql_query($sql, END_TRANSACTION) or message_die(GENERAL_ERROR, 'Could not update user warning text information', '', __LINE__, __FILE__, $sql);

			$redirect = append_sid('viewtopic.' . $phpEx . '?' . POST_POST_URL . '=' . $post_id);
			$l_redirect = sprintf($lang['Click_return_topic'], '<a href="' . $redirect . '">', '</a>');

			$template->assign_vars(array(
				'META' => '<meta http-equiv="refresh" content="3;url=' . $redirect . '">')
			);

			message_die(GENERAL_MESSAGE, $lang['Warning_successfully_edited'] . '<br /><br />' . $l_redirect);
		}
		else
		{
			//
			// Set template files
			//
			$template->set_filenames(array(
				'body' => 'warnings_posting_body.tpl')
			);

			$hidden_fields = '<input type="hidden" name="sid" value="' . $userdata['session_id'] . '" /><input type="hidden" name="' . POST_POST_URL . '" value="' . $post_id . '"><input type="hidden" name="mode" value="' . $mode . '" /><input type="hidden" name="' . POST_WARNING_URL . '" value="' . $warning_id . '" />';

			$warning_time_values = array(1, 3, 5, 7, 14, 30);

			$warning_time_select = '<select name="warning_time">';
			$warning_time_select .= '<option value="' . WARNING_INFINITY . '">' . $lang['wt_infinity'] . '</option>';

			for($i = 0; $i < count($warning_time_values); $i++)
			{
				$warning_time_select .= '<option value="' . ($warning_time_values[$i] * 86400) . '"' . ( ( ( $row['warning_expires'] - $row['warning_posted'] ) == ( $warning_time_values[$i] * 86400 ) ) ? ' selected="selected"' : '' ) .'>' . $lang['wt_' . $warning_time_values[$i]] . '</option>';
			}
			$warning_time_select .= '</select>';

			$template->assign_vars(array(
				'L_WARN_USER' => $lang['Warn_user'],
				'L_WARNING_TYPE' => $lang['Warning_type'],
				'L_WARNING_TYPE_WARNING' => $lang['Warning_type_warning'],
				'L_WARNING_TYPE_BAN' => $lang['Warning_type_ban'],
				'L_WARNING_TIME'=> $lang['Warning_time'],
				'L_WARNING_TEXT' => $lang['Warning_text'],
				'L_CANCEL' => $lang['Cancel'],

				'WARNING_TYPE_1_CHECKED' => $row['warning_type'] == ( WARNING_TYPE_WARNING ) ? 'checked="checked"' : '',
				'WARNING_TYPE_2_CHECKED' => $row['warning_type'] == ( WARNING_TYPE_BAN ) ? 'checked="checked"' : '',
				'WARNING_TEXT' => $row['warning_text'],

				'S_WARNING_TIME' => $warning_time_select,
				'S_WARNING_ACTION' => append_sid("warnings.$phpEx"),
				'S_HIDDEN_FIELDS' => $hidden_fields)
			);

			$template->pparse('body');

			include($phpbb_root_path . 'includes/page_footer.'.$phpEx);
		}
		break;

	case 'remove_warning':
	case 'delete_warning':
		$page_title = $lang['Mod_CP'];
		include($phpbb_root_path . 'includes/page_header.'.$phpEx);

		//
		// Start auth check
		//
		if ( !in_array($userdata['user_level'], array(ADMIN,MOD)) )
		{
			message_die(GENERAL_MESSAGE, $lang['Not_Moderator'], $lang['Not_Authorised']);
		}
		//
		// End Auth Check
		//

 		if ( empty($warning_id) )
 		{
 			message_die(GENERAL_MESSAGE, 'Warnings_not_enough_params');
 		}

		$sql = "SELECT * FROM " . WARNINGS_TABLE . " WHERE warning_id = '$warning_id'";
		$result = $db->sql_query($sql) or message_die(GENERAL_ERROR, 'Could not get warning information', '', __LINE__, __FILE__, $sql);
		$row = $db->sql_fetchrow($result)  or message_die(GENERAL_ERROR, 'Could not get warning information');

		if ( $userdata['user_level'] != ADMIN )
		{
			if ( $row['warning_poster_id'] != $userdata['user_id'] )
			{
				message_die(GENERAL_MESSAGE, 'Warning_cannot_process_not_yours');
			}
		}

		if ( $mode == 'remove_warning' && $row['warning_expires'] != WARNING_INFINITY && $row['warning_expires'] < time() )
		{
				message_die(GENERAL_MESSAGE, 'Warning_cannot_remove_expired');
		}

		if ( $confirm )
		{
  			if ( empty($warning_id) )
			{
				message_die(GENERAL_MESSAGE, $lang['None_selected']);
			}

			if ( $mode == 'remove_warning' )
			{
				$sql = "UPDATE " . WARNINGS_TABLE . " SET warning_expires = " . time() . " WHERE warning_id = '$warning_id'";
				$db->sql_query($sql) or message_die(GENERAL_ERROR, 'Could not remove warning information', '', __LINE__, __FILE__, $sql);

				$l_action = $lang['Warning_removed'];
			}
			else if ( $mode == 'delete_warning' )
			{
				if ( !$row['warning_proceed'] )
				{
					switch ( $row['warning_type'] )
					{
						case WARNING_TYPE_WARNING:
							$sql = "UPDATE " . USERS_TABLE . " SET user_warnings = user_warnings - 1 WHERE user_id = '" . $row['warning_user_id'] . "'";
						break;

						case WARNING_TYPE_BAN:
							$sql = "UPDATE " . USERS_TABLE . " SET user_banned = 0 WHERE user_id = '" . $row['warning_user_id'] . "'";
						break;
					}

					$db->sql_query($sql, BEGIN_TRANSACTION) or message_die(GENERAL_ERROR, 'Could not delete warning information', '', __LINE__, __FILE__, $sql);
				}

				$sql = "DELETE FROM " . WARNINGS_TABLE . " WHERE warning_id = '$warning_id'";
				$db->sql_query($sql, BEGIN_TRANSACTION) or message_die(GENERAL_ERROR, 'Could not delete warning information', '', __LINE__, __FILE__, $sql);

				$sql = "DELETE FROM " . WARNINGS_TEXT_TABLE . " WHERE warning_id = '$warning_id'";
				$db->sql_query($sql, END_TRANSACTION) or message_die(GENERAL_ERROR, 'Could not delete warning information', '', __LINE__, __FILE__, $sql);

				$l_action = $lang['Warning_deleted'];
			}

			$redirect = append_sid('profile.' . $phpEx . '?mode=viewprofile&amp;' . POST_USERS_URL . '=' . $row['warning_user_id']);
			$l_redirect = sprintf($lang['Click_return_profile'], '<a href="' . $redirect . '">', '</a>');

/*
			$template->assign_vars(array(
				'META' => '<meta http-equiv="refresh" content="3;url=' . $redirect . '">')
			);
*/

			message_die(GENERAL_MESSAGE, $l_action . '<br /><br />' . $l_redirect);
		}
		else
		{
			// Not confirmed, show confirmation message
  			if ( empty($warning_id) )
			{
				message_die(GENERAL_MESSAGE, $lang['None_selected']);
			}

			if ( $mode == 'remove_warning' )
			{
				$l_action = $lang['Confirm_remove_warning'];
			}
			else if ( $mode == 'delete_warning' )
			{
				$l_action = $lang['Confirm_delete_warning'];
			}

			$hidden_fields = '<input type="hidden" name="sid" value="' . $userdata['session_id'] . '" /><input type="hidden" name="mode" value="' . $mode . '" /><input type="hidden" name="' . POST_WARNING_URL . '" value="' . $warning_id . '" />';

			//
			// Set template files
			//
			$template->set_filenames(array(
				'confirm' => 'confirm_body.tpl')
			);

			$template->assign_vars(array(
				'MESSAGE_TITLE' => $lang['Confirm'],
				'MESSAGE_TEXT' => $l_action,

				'L_YES' => $lang['Yes'],
				'L_NO' => $lang['No'],

				'S_CONFIRM_ACTION' => append_sid("warnings.$phpEx"),
				'S_HIDDEN_FIELDS' => $hidden_fields)
			);

			$template->pparse('confirm');

			include($phpbb_root_path . 'includes/page_footer.'.$phpEx);
		}
		break;

	default:
		$page_title = $lang['Mod_CP'];
		include($phpbb_root_path . 'includes/page_header.'.$phpEx);

		break;
}

include($phpbb_root_path . 'includes/page_footer.'.$phpEx);

?>